local constants = require("server.constants")
local util = require("shared.utils")
local rpc = require("server.rpc")
require("server.compat")

return function(commands)
	function commands.moveUpdate(clientID, x, y, speedx, speedy)
		if not participants[clientID] then rpc.print("moveUpdate: invalid clientid [" .. clientID .. "]") return end
		participants[clientID].x = x
		participants[clientID].y = y
		participants[clientID].speedx = speedx
		participants[clientID].speedy = speedy

		boradcast(clientID, "moveUpdate", x, y, speedx, speedy)
	end


	function commands.moveFlying(clientID, flying)
		if not participants[clientID] then rpc.print("moveFlying: invalid clientid [" .. clientID .. "]") return end
		broadcast(clientID, "moveFlying", flying)
	end
	
	
	function commands.deletePhysics(clientID, x, y, width, height)
		if not WORLD_LOCK then
			if not participants[clientID] then rpc.print("deletePhysics: invalid clientid [" .. clientID .. "]") return end
			broadcast(clientID, "deletePhysics", x, y, width, height)
		end
	end

	function commands.drawPhysics(clientID, x, y, width, height)
			print("got physX")
		if not WORLD_LOCK then
			if not participants[clientID] then rpc.print("drawPhysics: invalid clientid [" .. clientID .. "]") return end
			broadcast(clientID, "drawPhysics",  x, y, width, height)
			print("got physX broadcasting")
		end
	end
end
